package Agent ;

import java.io.* ;
import java.net.* ;

public class AgentHandlerEx extends AgentHandler {

  public AgentHandlerEx( AgentServer server, Socket socket ) {
    super (server, socket);
  }

  protected void startAgentLoader() {
    String agentLoaderClassName = new String ("Agent.AgentLoaderEx");
    String agentLoaderSuperClassName = 
      new String ("Agent.DefaultAgentLoader");

    try {
      AgentClassLoader loader = new AgentClassLoader() ;
      loader.setMessages( true ) ;
      loader.addClassBytes( agentLoaderClassName,
        ClassBytesLoader.loadClassBytes( agentLoaderClassName ) ) ;
      loader.addClassBytes( agentLoaderSuperClassName,
        ClassBytesLoader.loadClassBytes( agentLoaderSuperClassName ) ) ;
      loader.forceLoadClass( agentLoaderSuperClassName ) ;
      Class agentLoaderClass = loader.forceLoadClass( agentLoaderClassName ) ;
      AgentLoader agentLoader = (AgentLoader)agentLoaderClass.newInstance() ;
      agentLoader.setServer( server ) ;
      agentLoader.setInputStream( socket.getInputStream() ) ;
      agentLoader.setOutputStream( socket.getOutputStream() ) ;
      agentLoader.start() ;
    } catch ( Exception e ) {
      e.printStackTrace() ;
    }
  }

  synchronized public void setMessages( boolean on ) { messagesOn = on ; }
}