package Agent ;

import java.io.* ;
import java.net.* ;
import java.util.Hashtable ;

public class AgentServer extends Thread {
  protected final static int defaultPort = 9999 ;
  protected ServerSocket serversocket ;
  protected int port ;
  protected boolean messagesOn = true ;

  public AgentServer() throws IOException {
    super( "AgentServer on port " + AgentServer.defaultPort + " started." ) ;
    port = AgentServer.defaultPort ;
    serversocket = new ServerSocket( port ) ;
  }

  public AgentServer( int port ) throws IOException {
    super( "AgentServer on port " + port + " started." ) ;
    this.port = port ;
    serversocket = new ServerSocket( port ) ;
  }
  
  public void run() {
    Socket socket ;

    try {
      while( true ) {
        socket = serversocket.accept() ;
        Print( "Nuova connessione da " + socket.getInetAddress().getHostAddress() +
           ":" + socket.getPort() ) ;
        newAgentHandler( this, socket ) ;
      }
    } catch ( IOException e ) {
      System.err.println( e ) ;
    }
  }

  protected void newAgentHandler( AgentServer server, Socket socket ) {
    AgentHandler Ahandler ;
    Ahandler = new AgentHandler( server, socket ) ;
    Ahandler.setMessages( messagesOn ) ;
    Ahandler.start() ;
  }

  protected void Print( String s ) {
    System.out.println( s ) ;
  }

  synchronized public void setMessages( boolean on ) { messagesOn = on ; }

  public static void main( String args[] ) throws IOException {
    if ( args.length > 2 )
      throw new IOException( "Syntax : AgentServer {<port> <messagesOn(1)>}" ) ;
    int port = AgentServer.defaultPort ;
    if ( args.length > 0 )
      port = Integer.parseInt( args[ 0 ] ) ;
    System.out.println( "Starting AgentServer on port " + port ) ;
    AgentServer agentServer = new AgentServer( port ) ;
    if ( args.length > 1 && args[1] == "1" )
      agentServer.setMessages( true ) ;
    agentServer.start() ;
  }
}