package Agent;

import java.io.* ;
import java.net.* ;

public class AgentServerExSecure extends AgentServerEx {

  public AgentServerExSecure() throws IOException { super() ; }
  public AgentServerExSecure( int port ) throws IOException { super( port ) ; }
  public AgentServerExSecure( int port, String agLoad ) throws IOException {
    super( port ) ;
  }

  protected void setSecurityManager() {
    try {
      System.setSecurityManager( new AgentSecurityManager() ) ;
    } catch ( SecurityException se ) {
      System.err.println( "Sec.Man. gi installato!" ) ;
    }
  }

  public static void main( String args[] ) throws IOException {
    if ( args.length > 3 )
      throw new IOException(
        "Syntax : AgentServerExSecure {<port> <messagesOn(1)> <loaderName>}" ) ;
    int port = AgentServer.defaultPort ;
    if ( args.length > 0 )
      port = Integer.parseInt( args[ 0 ] ) ;

    System.out.println( "Starting AgentServer on port " + port ) ;

    AgentServerExSecure agentServer ;
    if ( args.length > 2 )
      agentServer = new AgentServerExSecure( port, args[2] ) ;
    else
      agentServer = new AgentServerExSecure( port ) ;

    if ( args.length > 1 && args[1] == "1" )
      agentServer.setMessages( true ) ;

    agentServer.setSecurityManager() ;
    System.out.println( "Security Manager installato" ) ;

    agentServer.start() ;
  }
}