package Agent ;

import java.io.* ;
import java.net.* ;
import java.util.Hashtable ;

public class AgentServerSecure extends AgentServer {
  protected final static int defaultPort = 9999 ;
  protected ServerSocket serversocket ;
  protected int port ;
  protected boolean messagesOn = false ;

  public AgentServerSecure() throws IOException {
    super() ;
  }

  public AgentServerSecure( int port ) throws IOException {
    super( port ) ;
  }

  protected void setSecurityManager() {
    try {
      System.setSecurityManager( new AgentSecurityManager() ) ;
    } catch ( SecurityException se ) {
      System.err.println( "Sec.Man. gi installato!" ) ;
    }
  }

  public static void main( String args[] ) throws IOException {
    if ( args.length > 2 )
      throw new IOException( "Syntax : AgentServerSecure {<port> <messagesOn(1)>}" ) ;
    int port = AgentServer.defaultPort ;
    if ( args.length > 0 )
      port = Integer.parseInt( args[ 0 ] ) ;
    System.out.println( "Starting AgentServer on port " + port ) ;
    AgentServerSecure agentServer = new AgentServerSecure( port ) ;
    if ( args.length > 1 && args[1] == "1" )
      agentServer.setMessages( true ) ;
    agentServer.setSecurityManager() ;
    System.out.println( "Security Manager Installato" ) ;
    agentServer.start() ;
  }
}