// classe di utilit per caricare il contenuto di un file .class
// dal CLASSPATH.

package Agent ;

import java.io.* ;
import java.util.StringTokenizer ;

public class ClassBytesLoader {
  // pu essere chiamata anche da altre classi
  public static byte[] loadClassBytes( String className ) 
    throws IOException {				
		  int size ;
      byte[] classBytes ;
      InputStream is ;
      String fileSeparator = System.getProperty( "file.separator" ) ;
      className = className.replace('.', fileSeparator.charAt(0));
      className = className + ".class";

      String classpath = System.getProperty( "java.class.path" ) ;
      StringTokenizer st = new StringTokenizer(
          classpath, System.getProperty("path.separator") ) ;
      File classFile = null ;
      File dir = null ;
      while( st.hasMoreTokens() ) {
          dir = new File( st.nextToken() ) ;
          System.out.println( "directory : " + dir ) ;
          classFile = new File( dir, className ) ;
          if ( classFile.exists() )
            break ;
      }

      FileInputStream fi = new FileInputStream( classFile ) ;
      classBytes = new byte[ fi.available() ] ;
      fi.read( classBytes ) ;

      return classBytes;

      /*
        La vecchia implementazione che utilizzava
        ClassLoader.getSystemResourceAsStream ha inizianto a dare
        problemi: non trova pi la classe nel CLASSPATH, e quindi l'ho
        sostituita con la ricerca manuale della classe nelle varie
        directory del CLASSPATH.
        NON NE COMPRENDO IL MOTIVO :-(
      */

      //Cerca la classe (file.class) nel CLASSPATH .
      /*
 		  is = ClassLoader.getSystemResourceAsStream(className);
 		  //se is == null il file non e' stato trovato
      if (is == null)
        throw new FileNotFoundException(className);
      //se trovato il file legge la dimensione
      size = is.available();
      //crea l'array di byte data destinato a contenere il file
      classBytes = new byte[size];
      //legge il file
      is.read(classBytes);
      is.close();
      */
	}
}