// esempio di agente

import java.io.* ;
import Agent.* ;

public class TestAgentEx extends AgentEx {
  protected String host ;
  protected int port ;
  // dati di prova che saranno spediti insieme all'agente
  protected String s1 ;
  protected int n1 ;
  protected boolean firstMigration = true ;

  protected TAclass1 cl1 ;

  public TestAgentEx( String s, int p ) {
    super( "Test 2" ) ;
    host = s ;
    port = p ;
  }

  protected void execute() throws AgentException {
    setMessages( true ) ; // per debug
    System.out.println( "Salve io l'agente " + AgentName() ) ;
    s1 = new String( "Stringa di prova" ) ;
    n1 = 100 ;
    System.out.println( "Queste sono due mie variabili : " +
      s1 + ", " + n1 ) ;
    System.out.println( "Adesso migro su " + host + ":" + port ) ;
    migrate( host, port ) ;
    System.out.println( "Agente migrato" ) ;
  }

  public void onArrival() throws AgentException {
    System.out.println( "Salve, sono l'agente " + AgentName() +
      " appena arrivato..." ) ;
    System.out.println( "Queste sono due mie variabili : " +
      s1 + ", " + n1 ) ;
    System.out.println( "Creo un po' di classi..." ) ;
    cl1 = new TAclass1( "Hello everyone :-)" ) ;
    cl1.saySomething() ;
    if ( firstMigration ) {
      firstMigration = false ;
      migrate( host, port + 1 ) ;
    }
    System.out.println( "Fine, ciao dall'agente mobile :-)" ) ;
  }

  public static void main( String args[] ) {
    String host ;
    int port ;
    if ( args.length == 2 ) {
      host = args[0] ;
      port = Integer.parseInt( args[1] ) ;
    } else {
      host = new String ("127.0.0.1") ;
      port = 9999 ;
    }
    (new TestAgentEx( host, port )).start() ;
  }
}

class TAclassBase implements java.io.Serializable {
  String s ;

  public TAclassBase( String S ) { s = S ; }

  public void saySomething() {
    System.out.println( s + " dalla classe " + getClass().getName() ) ;
  }
}

class TAclass1 extends TAclassBase {

  TAclass2 cl2 ;

  public TAclass1( String S ) {
    super( S ) ;
    cl2 = new TAclass2( S ) ;
  }

  public void saySomething() {
    super.saySomething() ;
    cl2.saySomething() ;
  }
}

class TAclass2 implements java.io.Serializable {
  String s ;

  public TAclass2( String S ) { s = S ; }

  public void saySomething() {
    System.out.println( s + " dalla classe " + getClass().getName() ) ;
  }
}
